  <template>
  <button
    class="menu-btn w-8 h-8 tc-3 ol-bg-light"
    :class="{'has-unread-message': isHasUnreadMessage}"
    :id="ID.HAMBURGER"
    @click="drawer = true"
    >
    <svg-icon svg-name="hamburger" class="w-6 h-6 pointer-events-none" />
  </button>
  <el-drawer
    v-model="drawer"
    id="right-menu-drawer"
    title="Menu"
    :with-header="false"
    size="320px"
    :class="['menu-drawer', isMobile ? '' : 'desktop-menu-drawer']"
    :destroy-on-close="true"
  >
  <div class="menu-drawer__title" :class="addClassForNotGlobalTheme">
      <div v-if="selectedTheme === 'global'">
        <SwitchCommon
          v-if="isMobile"
          :is-showlabel="false"
          v-model:is-dark="isDarkModeToggle"
        />
        <div class="mr-5" v-else>&nbsp;</div>
      </div>
      <p>{{ $t("menu") }}</p>
      <button class="menu-btn ol-bg-light close-btn" :class="addClassForHeaderGlobalTheme" @click="drawer = false">
        <svg-icon svg-name="icon-x-close" class="w-6 h-6" />
      </button>
    </div>
    <div class="menu-drawer__body" ref="balanceEl" v-if="authenticated">
      <theme-desktop-global-components-menu-player-info @on-click-same-page="closeDrawer" />
    </div>
    <div class="menu-drawer__body global-light" :class="themeColor.Text.includes('playful') && 'menu-drawer-border'" ref="balanceEl" v-if="!authenticated">
      <div class="bg-background5 m-4 p-4 flex flex-col rounded-lg">
        <span class="border-b-[1px] border-b-[var(--border)] mb-4 pb-2 text-white opacity-50 text-xs text-start login-info">{{ $t('Please Login to check User Center and more details') }}</span>
        <div class="grid grid-cols-2 gap-2">
          <div class="logout-action min-w-[124px] !p-0">
            <button @click="onClickLogin">
              <span class="label">{{ $t("capital_login") }}</span>
            </button>
          </div>
          <div class="joinnow-action min-w-[124px] !p-0" >
            <button @click="onClickJoinnow" :id="ID.SIGNUP">
              <span class="label pointer-events-none">{{ $t("joinnow") }}</span>
            </button>
          </div>
        </div>
      </div>
    </div>
    <div class="menu-drawer__body">
      <el-scrollbar class="global-light-scroll pb-24" :height="`calc(100vh - ${balanceElHeight + 64}px)`">
        <theme-desktop-global-components-menu-user-center v-if="authenticated" @on-click-same-page="closeDrawer"/>
        <theme-desktop-global-components-menu-drawer-nav-links
          v-if="
            !isMobile ||
            themeColor.Text.includes('playful') ||
            isIndependentModule
          "
        />
        <nuxt-link
          v-if="(!isHelpCenterHidden && (isMobile || selectedTheme === 'playful'))"
          to="/help-center"
          class="help-center"
          active-class="active"
        >
          <div class="content">
            <div class="icon-container">
              <SvgIcon svg-name="icon-aboutus" class="w-5 h-5" />
            </div>
            <span class="label uppercase">
              {{ $t("help_center") }}
            </span>
          </div>
        </nuxt-link>
        <nuxt-link
          v-if="isContactEnabled"
          to="/contact-us"
          class="help-center"
          active-class="active"
        >
          <div class="content">
            <div class="icon-container">
              <SvgIcon svg-name="icon-contact-new" class="w-6 h-6" />
            </div>
            <span class="label uppercase text-sm">
              {{ $t("contact") }}
            </span>
          </div>
        </nuxt-link>
        <language-global-expand class="menu-drawer-border"/>
        <div class="logout-action" v-if="authenticated">
          <button @click="logout">
            <SvgIcon svg-name="signout-thin" class="w-5 h-5" />
            <span class="label">{{ $t("logout") }}</span>
          </button>
        </div>
      </el-scrollbar>
    </div>
  </el-drawer>
</template>

<script setup lang="ts">
import { IThemePropertiesFromApi } from '~~/models/companyThemePropertiesRespone';
import { store } from '~~/store';
import { memberMessageStore } from '~~/store/member-message';
import { EnumSelectedThemeMode } from "~~/models/enums/enumSelectedThemeMode";

const { logout } = useHeaderComponent();
const drawer = ref(false);
const balanceEl = ref();
const isMobile = !useIsDesktop();
const FALLBACK_BALANCE_HEIGHT = 257;
const balanceElHeight = ref<number>(FALLBACK_BALANCE_HEIGHT);
const { themeColor } = themePropertyHelper;
const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);

watch(
  () => drawer.value,
  () => {
    nextTick(()=> {
      setTimeout(() => {
        if (balanceEl.value && balanceEl.value.clientHeight) {
          balanceElHeight.value = balanceEl.value.clientHeight;
        } else {
          balanceElHeight.value = FALLBACK_BALANCE_HEIGHT;
        }
      }, 750);
    })
  }
);
const { getContactList } = useContactUs();
const authenticated = computed(() => store.state.auth);
const isHelpCenterHidden = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "help_center"
    )
).value.IsHidden;
const selectedTheme =  store.state.selectedThemeName;
const isContactEnabled = computed(() => !!getContactList.value.length);
const isDarkModeToggle = ref(store.state.selectedThemeMode === EnumSelectedThemeMode.Dark);
const { toggleLoginRegisterDialog } = commonHelper;
const { fetchMessages } = useMessage();
const router = useRouter();
const route = useRoute();
const addClassForNotGlobalTheme = computed(() =>
  selectedTheme !== 'global' ? 'menu-center' : ''
)
const addClassForHeaderGlobalTheme = computed(() =>
  selectedTheme === 'global' ? 'menu-header__global' : ''
)
const onClickLogin = () => {
  if (isMobile) toggleLoginRegisterDialog();
  else router.push('/login');
};
const closeDrawer = () => {
  drawer.value = false;
};

const isHasUnreadMessage = computed(() => {
  return memberMessageStore.getters.isHasUnreadMessage;
});
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
const onClickJoinnow = () => {
  if (isMobile) toggleLoginRegisterDialog(false);
  else router.push('/register');
};
watch(() => route.fullPath, () => {
  drawer.value = false;
}, {deep: true});
const isIndependentModule = useState(KEYS.IS_INDEPENDENT_MODULE);
</script>

<style>
#right-menu-drawer.desktop-menu-drawer .el-drawer__body {
  overflow: unset;
}
.menu-drawer .el-drawer__body {
  --el-drawer-padding-primary: 0;
  display: flex;
  flex-direction: column;
  align-items: flex-end;
  background: linear-gradient(
      0deg,
      rgba(0, 0, 0, 0.25) 0%,
      rgba(0, 0, 0, 0.25) 100%
    ),
    var(--background5, #1d2052);
  color: var(--text5, #fff);
}
</style>

<style scoped>
.menu-btn {
  position: relative;
  display: flex;
  padding: 4px;
  align-items: flex-start;
  gap: 8px;
  border-radius: 8px;
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}

.has-unread-message::before {
  content: "";
  position: absolute;
  top: -1px;
  right: -1px;
  width: 6px;
  height: 6px;
  border-radius: 50%;
  background: var(--failure);
}

.menu-btn svg {
  fill: var(--text5, #fff);
  transition: opacity 350ms ease;
}

.menu-btn:hover svg,
.menu-btn:focus svg {
  opacity: 1;
}

.menu-drawer__title {
  position: relative;
  display: flex;
  height: 64px;
  padding: 16px;
  justify-content: space-between;
  align-items: center;
  gap: 8px;
  flex-shrink: 0;
  align-self: stretch;
  background: linear-gradient(0deg, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 0) 100%),
    var(--background5, #1d2052);
}

.menu-center {
  justify-content: center !important;
}

.menu-drawer__title p {
  color: var(--text5);
  font-size: 14px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  text-transform: uppercase;
}

.menu-drawer__title button.menu-btn {
  position: absolute;
  right: 1rem;
  top: 50%;
  transform: translateY(-50%);
}

.menu-header__global {
  position: relative !important;
  right: 0 !important;
}

.menu-drawer__body {
  width: 100%;
}

.menu-drawer-border {
  position: relative;
}
.menu-drawer-border::after {
  content: "";
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  height: 2px;
  background: linear-gradient(
      0deg,
      rgba(255, 255, 255, 0.05) 0%,
      rgba(255, 255, 255, 0.05) 100%
    ),
    var(--background5, #1d2052);
}

.help-center {
  display: flex;
  height: 64px;
  padding: 0px 24px 0px 12px;
  position: relative;
  align-items: center;
  gap: 172px;
  align-self: stretch;
  /* transition: all 300ms ease; */
  /* background: linear-gradient(
      0deg,
      rgba(0, 0, 0, var(--opacity, 0.25)) 0%,
      rgba(0, 0, 0, var(--opacity, 0.25)) 100%
    ),
    var(--background5, #1d2052); */
}
.help-center:hover {
  --opacity: 0.05;
}
.help-center svg {
  fill: var(--text5);
}
.help-center.active::after {
  content: "";
  width: 2px;
  height: 12px;
  position: absolute;
  left: 4px;
  top: 50%;
  transform: translateY(-50%);
  border-radius: 1px;
  background: var(--primary, #31c46e);
}
.help-center .content {
  display: flex;
  align-items: center;
  opacity: 0.5;
  transition: opacity 300ms ease;
}
.help-center:hover .content,
.help-center.active .content {
  opacity: 1;
}
.help-center .icon-container {
  display: flex;
  width: 48px;
  height: 48px;
  justify-content: center;
  align-items: center;
  gap: 8px;
}
.help-center .icon-container {
  color: var(--text5, #fff);
  font-family: Roboto;
  font-size: 14px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  text-transform: uppercase;
}
.logout-action {
  display: flex;
  padding: 16px;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  gap: 8px;
  align-self: stretch;
}
.logout-action svg {
  fill: var(--text5);
}
.logout-action button {
  display: flex;
  padding: 8px 16px;
  justify-content: center;
  align-items: center;
  gap: 4px;
  align-self: stretch;
  border-radius: 4px;
  background: var(--secondary, #6b52cb);
}
.logout-action button .label {
  color: var(--text5);
  text-align: center;
  font-size: 12px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
}
.joinnow-action {
  display: flex;
  padding: 16px;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  gap: 8px;
  align-self: stretch;
}
.joinnow-action button {
  display: flex;
  padding: 8px 16px;
  justify-content: center;
  align-items: center;
  gap: 4px;
  align-self: stretch;
  border-radius: 4px;
  background: var(--primary, #31C46E);
}
.joinnow-action button .label {
  color: var(--text5);
  text-align: center;
  font-size: 12px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
}
</style>
<style lang="scss">
[theme-color="global_light_01"] {
  .login-info {
    color: var(--text5) !important;
  }
  .logout-action button .label,
  .joinnow-action button .label {
    color: var(--textBtn) !important;
  }
  .global-light-scroll {
    background: var(--background5);
  }
  .menu-drawer-border::after {
    background: linear-gradient(
      0deg,
      rgba(255, 255, 255, 0.5) 0%,
      rgba(255, 255, 255, 0.5) 100%
    ),
    var(--background5, #EDF0F7)
  }
  .menu-drawer .el-drawer__body {
    background: linear-gradient(0deg,rgba(0,0,0,.25) 0,rgba(0,0,0,.25) 100%),var(--background5,#EDF0F7)
  }
  .help-center {
    background: var(--background5) !important;
  }
  .logout-action svg {
    fill: var(--textBtn);
  }
}
</style>
